﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Operators
{
    class Customer { }
    class Program
    {
        static void Main(string[] args)
        {
            #region unary operators

            int negative = -1;
            int positive = 1;
            int result;

            result = +negative;    // result = -1
            result = +positive;    // result = 1

            int negInt = -1;
            decimal posDec = 1;
            float negFlt = -1.1f;
            double nanDbl = Double.NaN;
            int resInt;
            decimal resDec;
            float resFlt;
            double resDbl;

            resInt = -negInt;  // resInt = 1
            resDec = -posDec;  // resDec = -1 
            resFlt = -negFlt;  // resFlt = 1.1 
            resDbl = -nanDbl;  // resDbl = NAN 

            int count;
            int index = 6;

            count = index++;  // count = 6, index = 7

            count = ++index;  // count = 7, index = 7

            index = 6;

            count = index--;  // count = 6, index = 5

            index = 6;

            count = --index;	 // count = 5, index = 5

            bool bexpr = true;
            bool bresult = !bexpr;    // bresult = false
            bresult = !bresult;  // bresult = true 

            byte bitComp = 15;              // bitComp =  15 = 00001111b
            byte byteResult = (byte)~bitComp; // bresult = 240 = 11110000b

            #endregion

            #region binary operators

            int expr1 = 3;
            int expr2 = 7;
            int product;

            product = expr1 * expr2;  // product = 21

            int dividend = 45;
            int divisor = 5;
            int quotient;

            quotient = dividend / divisor;  // quotient = 9

            dividend = 33;
            divisor = 10;
            int remainder;

            remainder = dividend % divisor;  // remainder = 3

            int one = 1;
            int two;

            two = one + one;  // two = 2

            decimal debt = 537.50m;
            decimal payment = 250.00m;
            decimal balance;

            balance = debt - payment;  // balance = 287.50

            uint uintMax = 4294967295; // 11111111111111111111111111111111b
            uint byteMask;
            byteMask = uintMax << 8; // 11111111111111111111111100000000b

            uintMax = 4294967295; // 11111111111111111111111111111111b
            uint ushortMask;
            ushortMask = uintMax >> 16; // 00000000000000001111111111111111b

            int intMax = -1;          // 11111111111111111111111111111111b
            int shortMask;
            shortMask = intMax >> 16; // 10000000000000001111111111111111b

            decimal debit = 1500.00m;
            decimal credit = 1395.50m;

            bresult = debit == credit;  // bresult = false

            debit = 1500.00m;
            credit = 1395.50m;

            bresult = debit != credit;    // bresult = true
            bresult = !(debit == credit); // bresult = true

            short redBeads = 2;
            short whiteBeads = 23;

            bresult = redBeads < whiteBeads; // bresult=true, work harder

            redBeads = 13;
            whiteBeads = 12;

            bresult = redBeads > whiteBeads; // bresult=true, good job!

            float limit = 4.0f;
            float currValue = 3.86724f;
            bool Bresult;

            bresult = currValue <= limit; // bresult = true

            double rightAngle = 90.0d;
            double myAngle = 96.0d;
            bool isAbtuse;

            isAbtuse = myAngle >= rightAngle; // Yes, myAngle is abtuse

            byte oddMask = 1;  // 00000001b
            byte someByte = 85; // 01010101b
            bool isEven;

            isEven = (oddMask & someByte) == 0; //(oddMask & someByte) = 1

            byte option1 = 1; // 00000001b
            byte option2 = 2; // 00000010b
            byte totalOptions;

            totalOptions = (byte)(option1 | option2); // 00000011b

            byte invertMask = 255; // 11111111b
            someByte = 240; // 11110000b
            byte inverse;

            inverse = (byte)(someByte ^ invertMask); //inversion=00001111b

            bool inStock = false;
            decimal price = 18.95m;
            bool buy;

            buy = inStock & (price < 20.00m); // buy = false

            int mileage = 2305;
            int months = 4;
            bool changeOil;

            changeOil = mileage > 3000 | months > 3; // changeOil = true

            bool availFlag = false;
            bool toggle = true;
            bool available;

            available = availFlag ^ toggle; // available = true

            inStock = false;
            price = 18.95m;

            buy = inStock && (price < 20.00m); // buy = false

            mileage = 4305;
            months = 4;

            changeOil = mileage > 3000 || months > 3; // changeOil = true

            decimal totalSpending = 3692.48m;
            decimal avgSpending;

            bool onBudget = totalSpending > 4000.00m
                && totalSpending < CalcAvg();

            int total = 7;
            total += 3; // total = 10

            long democratVotes = 1753829380624;
            long republicanVotes = 1753829380713;

            string headline = democratVotes != republicanVotes ?
                              "We Finally Have a Winner!" : Recount();

            #endregion

            #region other operators

            int i = 0;
            bool isTest = i is int; // isTest = true

            object obj = new Customer();
            string cust = obj as string;

            Console.WriteLine("cust {0} a string.",
                cust == null ? "is not" : "is"); // cust is not a string.

            unsafe
            {
                int intSize = sizeof(int); // intSize = 4
            }

            Type myType = typeof(int);
            Console.WriteLine(
                "The int type: {0}", myType); // The int type: Int32

            short val1 = 20000, val2 = 20000;
            //short myShort = checked((short)(val1 + val2)); // error

            short val3 = 20000, val4 = 20000;
            short myShort =
                unchecked((short)(val3 + val4)); // error ignored

            #endregion

            #region statement basics

            decimal loanOrigination = 1m;
            decimal appraisal = 1m;
            decimal titleSearch = 1m;
            decimal insuranceAdvance = 1m;
            decimal taxAdvance = 1m;
            decimal points = 1m;
            decimal realtorCommission = 1m;
            decimal whateverElseTheyCanRipYouOffFor = 1m;

            decimal closingCosts = loanOrigination
                       + appraisal
                       + titleSearch
                       + insuranceAdvance
                       + taxAdvance
                       + points
                       + realtorCommission
                       + whateverElseTheyCanRipYouOffFor;


            bool myBool = true;

            {
                int myInt = 5;
                myBool = false;
            }

            //myInt = 6;

            loop:        // a label named "loop"
        jumphere:    // a label named "jumphere"

            result = 5 + 3 * 9;  // result = 32

            result = (5 + 3) * 9;  // result = 72

            #endregion

            #region selection statements

            if (args.Length == 0)
            {
                Console.WriteLine("Invalid # of command line args");
            }

            if (args.Length == 0)
            {
                Console.WriteLine("Invalid # of command line args");
            }
            else
            {
                Console.WriteLine("You entered: {0}?", args[0]);
            }

            if (args.Length == 0)
            {
                Console.WriteLine("Invalid # of command line args");
            }
            else if (args.Length == 1)
            {
                Console.WriteLine("You entered: {0}?", args[0]);
            }
            else
            {
                Console.WriteLine("Too many arguments!\a");
            }

            string choice = "R";

            switch (choice)
            {
                case "A":
                    Console.WriteLine("Add Site");
                    break;
                case "S":
                    Console.WriteLine("Sort List");
                    break;
                case "R":
                    Console.WriteLine("Show Report");
                    break;
                case "Q":
                    Console.WriteLine("GoodBye");
                    break;
                default:
                    Console.WriteLine("Huh??");
                    break;
            }

            switch (choice)
            {
                case "a":
                case "A":
                    Console.WriteLine("Add Site");
                    break;
                case "s":
                case "S":
                    Console.WriteLine("Sort List");
                    break;
                case "r":
                case "R":
                    Console.WriteLine("Show Report");
                    break;
                case "q":
                case "Q":
                    Console.WriteLine("GoodBye");
                    break;
                default:
                    Console.WriteLine("Huh??");
                    break;
            }

            switch (choice)
            {
                case "A":
                    Console.WriteLine("Add Site");
                    break;
                case "S":
                    Console.WriteLine("Sort List");
                    break;
                case "R":
                    Console.WriteLine("Show Report");
                    break;
                case "V":
                    Console.WriteLine("View Sorted Report");
                    // Sort First
                    goto case "R";
                case "Q":
                    Console.WriteLine("GoodBye");
                    break;
                default:
                    Console.WriteLine("Huh??");
                    break;
            }

            #endregion

            #region looping statements

            string doAgain = "Y";
            count = 0;
            string[] siteName = new string[10];

            while (doAgain == "Y")
            {
                Console.Write("Please Enter Site Name: ");
                siteName[count++] = Console.ReadLine();

                Console.Write("Add Another?: ");
                doAgain = Console.ReadLine();
            }

            //string doAgain = "Y";

            //while (doAgain == "Y") ; // loop forever
            //{
            //    // this is never executed
            //}

            do
            {
                Console.WriteLine("");
                Console.WriteLine("A - Add Site");
                Console.WriteLine("S - Sort List");
                Console.WriteLine("R - Show Report\n");

                Console.WriteLine("Q - Quit\n");

                Console.Write("Please Choose (A/S/R/Q): ");

                choice = Console.ReadLine();

                switch (choice)
                {
                    case "a":
                    case "A":
                        Console.WriteLine("Add Site");
                        break;
                    case "s":
                    case "S":
                        Console.WriteLine("Sort List");
                        break;
                    case "r":
                    case "R":
                        Console.WriteLine("Show Report");
                        break;
                    case "q":
                    case "Q":
                        Console.WriteLine("GoodBye");
                        break;
                    default:
                        Console.WriteLine("Huh??");
                        break;
                }

            } while ((choice = choice.ToUpper()) != "Q");

            int n = siteName.Length - 2;
            int j, k;
            string save;

            for (k = n - 1; k >= 0; k--)
            {
                j = k + 1;
                save = siteName[k];
                siteName[n + 1] = save;

                while (string.Compare(save, siteName[j]) > 0)
                {
                    siteName[j - 1] = siteName[j];
                    j++;
                }
                siteName[j - 1] = save;
            }

            foreach (string site in siteName)
            {
                Console.WriteLine("\t{0}", site);
            }

            goto label;

        label:

            int someValue = 3;

            do
            {
                // some processing
                while (true/* some Boolean condition */)
                {
                    // some processing
                    for (int ii = 0; ii < someValue; ii++)
                    {
                        if (true/* some Boolean condition */)
                        {
                            goto quickExit;
                        }
                    }
                }
            } while (true/* some Boolean condition */);

    quickExit:

            // won't compile
            //while (false/* some Boolean condition */)
            //{
            //  // some processing
            //  innerLoop:
            //  // more processing
            //}

            //goto innerLoop;

            while (doAgain == "Y")
            {
                Console.Write("Please Enter Site Name: ");
                siteName[count++] = Console.ReadLine();

                Console.Write("Add Another?: ");
                doAgain = Console.ReadLine();

                if (count >= 5)
                {
                    break;
                }
            }

            string response = "Y";
            string filter = "http";

            foreach (string site in siteName)
            {
                if (response.ToUpper() == "Y" &&
                  site != null &&
                  site.IndexOf(filter) == -1)
                {
                    continue;
                }

                Console.WriteLine("\t{0}", site);
            }

            Console.ReadKey();

            return;

            #endregion
        }

        private static string Recount()
        {
            return string.Empty;
        }

        private static decimal CalcAvg()
        {
            return 0m;
        }
    }
}
