﻿using System;

/// <summary>
///     Custom Attribute Example.
/// </summary>
[
    Tracker("CR-0001",
            "some fix",
            EngineerId = "Joe",
            ChangeDate = "07/04/2008")
]
class SomeProgram
{
    static void Main(string[] args)
    {
        SomeProgram sp = new SomeProgram();
    }
}

[
    AttributeUsage(AttributeTargets.All,
                   AllowMultiple = true,
                   Inherited = true)
]
class TrackerAttribute : Attribute
{
    public string ProblemId;
    public string EngineerId;
    private string fixDescription;
    private DateTime changeDate;

    public string FixDescription
    {
        get
        {
            return fixDescription;
        }
        set
        {
            fixDescription = value;
        }
    }

    public string ChangeDate
    {
        get
        {
            return changeDate.ToString("d");
        }
        set
        {
            changeDate = DateTime.Parse(value);
        }
    }

    public TrackerAttribute()
    {
        ProblemId = "UNASSIGNED";
        EngineerId = "Unidentified Engineer";
        FixDescription = "No description provided";
        ChangeDate = "01/01/2009";
    }

    public TrackerAttribute(string problemId, string fixDescription)
    {
        ProblemId = problemId;
        EngineerId = "Unidentified Engineer";
        FixDescription = fixDescription;
        ChangeDate = "01/01/2009";
    }
}
