using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Resources;
using System.Threading;
using System.Globalization;

namespace MultiCulture
{
	/// <summary>
	/// Summary description for MultiCulture.
	/// </summary>
	public class MultiCulture : System.Windows.Forms.Form
	{
		ResourceManager multiRes;

		private System.Windows.Forms.PictureBox flagPic;
		private System.Windows.Forms.Label greetingLbl;
		private System.Windows.Forms.ComboBox cultureCbx;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MultiCulture()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			multiRes = new ResourceManager("multiculture", this.GetType().Assembly);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.flagPic = new System.Windows.Forms.PictureBox();
			this.cultureCbx = new System.Windows.Forms.ComboBox();
			this.greetingLbl = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// flagPic
			// 
			this.flagPic.Location = new System.Drawing.Point(64, 24);
			this.flagPic.Name = "flagPic";
			this.flagPic.Size = new System.Drawing.Size(168, 104);
			this.flagPic.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.flagPic.TabIndex = 0;
			this.flagPic.TabStop = false;
			// 
			// cultureCbx
			// 
			this.cultureCbx.DisplayMember = "en-US";
			this.cultureCbx.DropDownWidth = 121;
			this.cultureCbx.Items.AddRange(new object[] {
															"en-US",
															"en-GB",
															"ja-JP",
															"de-CH",
															"it",
															"mars"});
			this.cultureCbx.Location = new System.Drawing.Point(88, 216);
			this.cultureCbx.Name = "cultureCbx";
			this.cultureCbx.Size = new System.Drawing.Size(121, 21);
			this.cultureCbx.TabIndex = 2;
			this.cultureCbx.Text = "en-US";
			this.cultureCbx.SelectedIndexChanged += new System.EventHandler(this.cultureCbx_SelectedIndexChanged);
			// 
			// greetingLbl
			// 
			this.greetingLbl.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.greetingLbl.Location = new System.Drawing.Point(64, 160);
			this.greetingLbl.Name = "greetingLbl";
			this.greetingLbl.Size = new System.Drawing.Size(168, 23);
			this.greetingLbl.TabIndex = 1;
			this.greetingLbl.Text = "greeting";
			this.greetingLbl.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// MultiCulture
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cultureCbx,
																		  this.greetingLbl,
																		  this.flagPic});
			this.Name = "MultiCulture";
			this.Text = "Localization Demo";
			this.Load += new System.EventHandler(this.MultiCulture_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MultiCulture());
		}

		private void SetLocalizedResources()  
		{
			flagPic.Image = (System.Drawing.Image)multiRes.GetObject("flag");
			greetingLbl.Text = multiRes.GetString("greeting");
		}

		private void MultiCulture_Load(object sender, System.EventArgs e)
		{
			SetLocalizedResources();
		}

		private void cultureCbx_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Thread.CurrentThread.CurrentUICulture = new CultureInfo(this.cultureCbx.SelectedItem.ToString());
			SetLocalizedResources();
		}

	}
}
