using System;
using System.Diagnostics;

	/// <summary>
	///		TraceSwitch Demo.
	/// </summary>
class TraceSwitchDemo
{
	static TraceSwitch traceOutput = new 
		TraceSwitch("TraceOutput", "TraceSwitch Demo");

	void SetupDebugListener()
	{
		TextWriterTraceListener myListener = 
			new TextWriterTraceListener(Console.Out);

		Trace.Listeners.Add(myListener);
	}

	void CheckState()
	{
		Trace.WriteLineIf(traceOutput.TraceInfo, "Trace: Entered CheckState()");
	}

	static void Main(string[] args)
	{
		TraceSwitchDemo tsd = new TraceSwitchDemo();

		tsd.SetupDebugListener();
		tsd.CheckState();

		Console.ReadLine();
	}
}
